package com.ynet.life.sujrb.controller;

import com.ynet.gene.accesscontrol.AccessInfo;
import com.ynet.gene.core.Context;
import com.ynet.gene.core.GENEConstance;
import com.ynet.gene.core.GENEException;
import com.ynet.gene.session.Session;
import com.ynet.gene.web.servlet.ModelAndView;
import com.ynet.gene.web.servlet.mvc.GENEFlowExecuteResult;
import com.ynet.life.base.LifeConstants;
import com.ynet.life.base.LifeStandard;
import com.ynet.life.base.MVCEntity;
import com.ynet.life.base.TEntity;
import com.ynet.life.base.Trace;
import com.ynet.life.exception.TranFailException;
import com.ynet.life.file.download.FileAccessValidator;
import com.ynet.life.mvc.SimpleRequest;
import com.ynet.life.mvc.XMLViewRequestController;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import javax.servlet.ServletOutputStream;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/* loaded from: com_ynet_life_sujrb_controller.jar:com/ynet/life/sujrb/controller/FileDownLoadController.class */
public class FileDownLoadController extends XMLViewRequestController {
    private FileAccessValidator validator = null;

    /* JADX WARN: Multi-variable type inference failed */
    /* JADX WARN: Type inference failed for: r0v10, types: [java.lang.Exception] */
    /* JADX WARN: Type inference failed for: r0v20, types: [com.ynet.gene.core.Context] */
    /* JADX WARN: Type inference failed for: r0v71 */
    /* JADX WARN: Type inference failed for: r0v72 */
    /* JADX WARN: Type inference failed for: r0v9 */
    public ModelAndView doRequest(HttpServletRequest httpServletRequest, HttpServletResponse httpServletResponse) throws Exception {
        SimpleRequest simpleRequest = (SimpleRequest) this.simpleRequests.get((String) httpServletRequest.getAttribute(GENEConstance.ATTR_ACTIONID));
        boolean z = this.openMonitor;
        ?? r0 = z;
        if (z) {
            AccessInfo accessInfo = this.accessInfo;
            accessInfo.newAccess();
            r0 = accessInfo;
        }
        try {
            Session session = null;
            if (simpleRequest.isCheckSession() && isCheckSession()) {
                Session doSessionCheck = doSessionCheck(httpServletRequest, httpServletResponse);
                session = doSessionCheck;
                if (doSessionCheck == null) {
                    Trace.logError("LifeSession", "Session not exist or timeout");
                    throw LifeConstants.EXCEPTION_SESSION_TIMEOUT;
                }
            }
            preActionWork(httpServletRequest, session, simpleRequest);
            GENEFlowExecuteResult executeGENELogicBizFlow = executeGENELogicBizFlow(httpServletRequest, httpServletResponse, session);
            if (executeGENELogicBizFlow.e != null) {
                Trace.logError(GENEConstance.GENE_MVC, executeGENELogicBizFlow.e.getMessage(), executeGENELogicBizFlow.e);
                throw new GENEException(executeGENELogicBizFlow.e);
            }
            r0 = executeGENELogicBizFlow.context;
            try {
                String str = (String) r0.get("downloadFile");
                File file = new File(str);
                if (!file.exists()) {
                    Trace.logError(GENEConstance.GENE_MVC, "文件[" + str + "]不存在");
                    throw LifeConstants.EXCEPTION_FILE_NOT_FOUND;
                }
                getValidator().validate(str, (Context) r0);
                FileInputStream fileInputStream = null;
                ServletOutputStream servletOutputStream = null;
                try {
                    try {
                        fileInputStream = new FileInputStream(file);
                        httpServletResponse.setHeader("Content-disposition", "attachment; filename=\"" + file.getName() + "\"");
                        httpServletResponse.setHeader("Content-Length", String.valueOf(file.length()));
                        ServletOutputStream outputStream = httpServletResponse.getOutputStream();
                        servletOutputStream = outputStream;
                        outputStream.flush();
                        while (true) {
                            int read = fileInputStream.read();
                            if (read == -1) {
                                break;
                            }
                            servletOutputStream.write(read);
                        }
                        servletOutputStream.flush();
                        try {
                            fileInputStream.close();
                            if (servletOutputStream != null) {
                                servletOutputStream.close();
                            }
                        } catch (IOException unused) {
                            Trace.logWarning(GENEConstance.GENE_MVC, "文件对象关闭异常");
                        }
                    } catch (Throwable th) {
                        if (0 != 0) {
                            try {
                                fileInputStream.close();
                            } catch (IOException unused2) {
                                Trace.logWarning(GENEConstance.GENE_MVC, "文件对象关闭异常");
                                throw th;
                            }
                        }
                        if (0 != 0) {
                            servletOutputStream.close();
                        }
                        throw th;
                    }
                } catch (IOException e) {
                    Trace.logError(GENEConstance.GENE_MVC, "文件下载异常", e);
                    if (fileInputStream != null) {
                        try {
                            fileInputStream.close();
                        } catch (IOException unused3) {
                            Trace.logWarning(GENEConstance.GENE_MVC, "文件对象关闭异常");
                        }
                    }
                    if (servletOutputStream != null) {
                        servletOutputStream.close();
                    }
                }
                r0.terminate();
                return null;
            } catch (Throwable th2) {
                r0.terminate();
                throw th2;
            }
        } catch (Exception e2) {
            r0.printStackTrace();
            return null;
        }
    }

    /* JADX WARN: Multi-variable type inference failed */
    /* JADX WARN: Type inference failed for: r0v12, types: [com.ynet.life.sujrb.controller.FileDownLoadController] */
    /* JADX WARN: Type inference failed for: r0v4 */
    /* JADX WARN: Type inference failed for: r0v5, types: [java.lang.Throwable] */
    /* JADX WARN: Type inference failed for: r0v7, types: [com.ynet.life.file.download.FileAccessValidator] */
    public FileAccessValidator getValidator() throws GENEException {
        if (this.validator == null) {
            ?? r0 = this;
            synchronized (r0) {
                r0 = this.validator;
                if (r0 == 0) {
                    try {
                        String selfDefineSettingsValue = LifeStandard.getSelfDefineSettingsValue("downloadValidatorClass");
                        String validatorClass = selfDefineSettingsValue;
                        if (selfDefineSettingsValue == null) {
                            validatorClass = "com.ynet.life.file.download.DefaultFileAccessValidator";
                        }
                        r0 = this;
                        r0.validator = (FileAccessValidator) Class.forName(validatorClass).newInstance();
                    } catch (Exception e) {
                        Trace.logError("LifeFile", "instantiate download file validator failed.", e);
                        throw new GENEException("instantiate download file validator failed.", e);
                    }
                }
            }
        }
        return this.validator;
    }

    protected void preContextWork(HttpServletRequest request, Context context, SimpleRequest simpleRequest) throws TranFailException {
        if (simpleRequest != null && simpleRequest.isCheckSession() && isCheckSession()) {
            addBusinessInfo(request, context, simpleRequest);
        }
    }

    /* JADX WARN: Multi-variable type inference failed */
    /* JADX WARN: Type inference failed for: r0v11, types: [boolean] */
    /* JADX WARN: Type inference failed for: r0v15, types: [com.ynet.life.cache.Cache] */
    private void addBusinessInfo(HttpServletRequest request, Context context, SimpleRequest simpleRequest) throws TranFailException {
        MVCEntity mvcEntity;
        if (simpleRequest != null) {
            String appKey = request.getParameter(TEntity.appKeyFieldname);
            Session session = (Session) this.sessionManager.getSessions().get(appKey);
            String cacheServiceFlag = LifeStandard.getSelfDefineSettingsValue("cacheServiceFlag");
            TranFailException equals = "true".equals(cacheServiceFlag);
            if (equals != 0) {
                try {
                    equals = LifeStandard.getCache("sessionData_cache");
                    mvcEntity = (MVCEntity) equals.get(appKey);
                } catch (TranFailException e) {
                    equals.printStackTrace();
                    throw new TranFailException(e);
                }
            } else {
                mvcEntity = (MVCEntity) session.getAttribute(appKey);
            }
            String bankId = mvcEntity.getBankId();
            mvcEntity.getChannel();
            String format = request.getParameter(TEntity.responseFormat);
            String uri = request.getRequestURI();
            String method = request.getMethod();
            context.put(TEntity.sessionIdFieldName, appKey);
            context.put(TEntity.bankIdFieldName, bankId);
            context.put(TEntity.appKeyFieldname, appKey);
            context.put(TEntity.uriFieldname, uri);
            context.put(TEntity.responseFormat, format);
            context.put(TEntity.requestMethod, method);
            context.put(TEntity.IS_LOGIN, TEntity.isSign_NO);
            context.put(TEntity.language, mvcEntity.getLanguage());
            context.put(TEntity.LOGIN_ID, mvcEntity.getLogonId());
            context.put(TEntity.USER_NAME, mvcEntity.getUserName());
            context.put(TEntity.USER_BELONGS_BRANCH, mvcEntity.getUserBelongsBranch());
            context.put(TEntity.USER_BRANCH_ID, mvcEntity.getUserBranchId());
            context.put(TEntity.BRANCHNAME, mvcEntity.getBranchName());
            context.put(TEntity.REGIONS_IDS, mvcEntity.getRegionIds());
            context.put(TEntity.USER_PHONE, mvcEntity.getUserPhone());
            context.put(TEntity.ROLE_ID, mvcEntity.getRoleId());
            context.put(TEntity.ROLE_TYPE, mvcEntity.getRoleType());
            context.put(TEntity.USER_ID, mvcEntity.getUserId());
            context.put(TEntity.COR_ORECODE, mvcEntity.getSession_orgCode());
            context.put(TEntity.CLASSNO, mvcEntity.getClassNo());
        }
    }
}
